const fs = require('fs');
const exec = require('child_process').exec;
const moment = require('moment');
const request = require('request');

let status = 'ready';
let version = null;
let buildVersion = null;
let isLast = false;
let currentCode = null;
const d = moment().format('YYYYMMDDHHmm');
const packageDir = '../../package/' + d;
fs.exists(packageDir, (r) => {
  if (!r) {
    fs.mkdir(packageDir, () => {});
  }
});

function success(data) {
  return JSON.stringify({
    code: 200,
    data: data
  });
}
function root(req, res) {
  res.end('aaa');
}
function getStatus(req, res) {
  if (!isLast) {
    res.end(status);
  } else {
    res.end(JSON.stringify({
      code: 500
    }));
  }
}
function initBuildInfo(req, res) {
  status = 'building';
  if (!version) {
    version = req.query.version;
    buildVersion = req.query.buildVersion;
  }
  res.end(success({
    version: version,
    buildVersion: buildVersion,
  }));
};

function promotionChannelCode(req, res) {
  var promotionChannelConfig = fs.readFileSync('../js/promotionChannelConfig.js');
  promotionChannelConfig = promotionChannelConfig.toString().split('=')[1];
  promotionChannelConfig = JSON.parse(promotionChannelConfig);
  let list = promotionChannelConfig.list;
  let code = promotionChannelConfig.code;
  let index = list.indexOf(code);
  currentCode = code;
  if (list.indexOf(code) === list.length - 1) {
    isLast = true;
  }
  console.log('提交渠道代码')
  exec('git add ../&&git commit -m build-' + code + '&&git svn rebase&&git svn dcommit', {
    silent: false
  }, function(err, stdout, stderr) {
    let newCode;
    if (index >= list.length - 1) {
      newCode = list[0];
    } else {
      newCode = list[index + 1];
    }
    fs.writeFileSync(
      '../js/promotionChannelConfig.js',
      'var promotionChannelConfig = ' + JSON.stringify({
        list: list,
        code: newCode
      })
    );
    if (err) {
      console.log(err);
      console.log('stdout', stdout);
      console.log('stderr', stderr);
      if (stdout.toString().indexOf('working tree clean') === -1) {
        res.end(err.toString());
        return;
      }
    }
    res.end(success());
  });
};

function resetPromotionChannelCode(req, res) {
  var promotionChannelConfig = fs.readFileSync('../js/promotionChannelConfig.js');
  promotionChannelConfig = promotionChannelConfig.toString().split('=')[1];
  promotionChannelConfig = JSON.parse(promotionChannelConfig);
  let list = promotionChannelConfig.list;
  let code = list[0];
  fs.writeFileSync(
    '../js/promotionChannelConfig.js',
    'var promotionChannelConfig = ' + JSON.stringify({
      list: list,
      code: code
    })
  );
  res.end(success());
};
function saveApk(req, res) {
  const { url } = req.body;
  const apkPath = `../../package/${d}/${currentCode}_${version}.apk`;
  console.log(apkPath);
  const stm = fs.createWriteStream(apkPath);
  console.log(url);
  request(url).on('end', () => {
    res.end(success({ isLast }));
  }).pipe(stm);
}

module.exports = function(app) {
  app.use('/promotionChannelCode', promotionChannelCode);
  app.use('/resetPromotionChannelCode', resetPromotionChannelCode);
  app.use('/initBuildInfo', initBuildInfo);
  app.use('/status', getStatus);
  app.use('/saveApk', saveApk);
  app.use('/', root);
};
