import $ from 'jquery';
import axios from 'axios';
import send from './send';

const ajax = axios.create({
  baseURL: 'http://127.0.0.1:3000',
  timeout: 300000,
});

function execScript(scriptText) {
  $(document.body).append([
    '<script>',
      scriptText,
    '</script>',
  ].join(''));
}
init();
function init() {
  var timer = setInterval(() => {
    console.log('radio length', $('.iradio_minimal-green').length);
    if ($('.iradio_minimal-green').length > 3) {
      execScript('jQuery(".android.pf-name").click()');
      execScript('jQuery("[name=packType]").closest("label").click()');
      initBuildInfo(
        $('#ver-area').data('ver'),
        $('#and-ver-code').val(),
      );
      clearInterval(timer);
    }
  }, 200)
}
function initBuildInfo(version, buildVersion) {
  return ajax.get('/status').then((res) => {
    if (res.data === 'ready') {
      return ajax.get('/resetPromotionChannelCode');
    }
  })
    .then(() => ajax.get('promotionChannelCode'))
    .then(() => {
      const config = {
        params: {
          version,
          buildVersion,
        }
      };
      return ajax.get('/initBuildInfo', config);
    })
    .then((res) => {
      const { version, buildVersion } = res.data.data;
      let versionArr = version.split('.');
      const versionArea = $('.ver-area input');
      versionArea[0].value = versionArr[0];
      versionArea[1].value = versionArr[1];
      versionArea[2].value = versionArr[2];
      $('#and-ver-code').val(buildVersion);
      execScript('jQuery("button.package").click()');
      const timer = setInterval(() => {
        const btn = $('#pack-succ .compile-succ .android-wrap a.down-link');
        console.log('find download btn', btn);
        if (btn.attr('href').indexOf('https://') === -1) {
          return;
        }
        clearInterval(timer);
        const url = btn.attr('href');
        ajax.post('/saveApk', { url }).then((res) => {
          if (!res.data.data.isLast) {
            location.reload();
            return;
          }
          alert('打包成功')
        });
      }, 2000);
    });
}