mui.plusReady(function () {
	var mainForm, user, order, orderNo, purchasePrice, productGoldWeight, totalWeight, orderAmount, consumeGoldAmount;
	var main = function () {
		mainForm = $('#mainForm');
		$.getToken();

		// 获取订单数据
		orderNo = getParam('orderNo');
		initData();
	};

	var initData = function () {
		$.request({
			url: "/order/consume/query",
			data: {
				orderNo: orderNo
			},
			successCallBack: function (response) {
				order = response.data;
				setOrderDetail(response.data);
			}
		});
	};

	var setOrderDetail = function () {
		// 设置订单编号
		$('#orderNo').text(order.orderNo);

		// 设置订单详情信息
		var weightArr = order.productGoldWeightStr.split(',');
		var skuArr = order.productSku.split(',');
		for (var i = 0; i < skuArr.length; i++) {
			var temp = [];
			temp.push('<div class="item">');
			temp.push('<span class="s1">#' + (i + 1) + '</span>');
			temp.push('<span class="s2">' + skuArr[i] + '</span>');
			temp.push('<span class="s3">' + weightArr[i] + '克</span>');
			temp.push('</div>');
			$('#orderDetail').append(temp.join(''));
		}
		$.each(order.productGoldWeightStr.split(','), function () {});

		// 设置是否补差价		
		$('[name="supplementStatus"]').val(order.supplementStatus);

		// 设置黄金牌价
		purchasePrice = order['goldUnitPrice'];
		$('[name="goldUnitPrice"]').val(purchasePrice);
		$('#gold_price_span .s2').text(('' + purchasePrice).split('.')[0]);
		$('#gold_price_span .s3').text('.' + (('' + purchasePrice).split('.')[1] || "00"));

		// 设置购入克重
		productGoldWeight = order['productGoldWeight'];
		$('#purchase_weight_span').text(productGoldWeight + 'g');

		// 设置应付金额
		orderAmount = order['orderAmount'];
		$('#pay_money_1').text(('' + orderAmount).split('.')[0]);
		$('#pay_money_2').text('.' + (('' + orderAmount).split('.')[1] || "00"));

		// 设置总计订单黄金重量和订单金额		
		$('#total_weight .s2').text(('' + order['productGoldWeight']).split('.')[0]);
		$('#total_weight .s3').text('.' + (('' + order['productGoldWeight']).split('.')[1] || "00") + ' g');
		$('[name="orderAmount"]').val(orderAmount);

		$.request({
			type: "GET",
			url: "/member/query",
			onsuccess: function (response) {
				user = response.data;
				totalWeight = user.totalWeight;
				$('#gold_weight_span').html(totalWeight);
				if (totalWeight > 0) {
					$('.js-useBalance').show();
				}
				
				$('#realName_p').text(user.realName);
				$('[name="receiverMobile"]').val(user.mobile);
			
				$('#identityCardNo_p').text(user.identityCardNo);
				
				if(user.realName) {
					$('[name="realName"]').val(user.realName).attr('readonly', 'readonly');
				}
	
				if(user.identityCardNo) {
					$('[name="identityCardNo"]').val(user.identityCardNo).attr('readonly', 'readonly');
				}
				if (user) {
					localStorage.setItem('user', JSON.stringify(response.data));
				}
			},
			onerror: function () {
				alert('查询客户信息失败');
			}
		});

		countConsume();
	};

	var countConsume = function () {
		$('[name="consumeGoldWeight"]').val(order.consumeGoldWeight);
		$('[name="consumeGoldAmount"]').val(order.consumeGoldAmount);
		$('[name="supplementAmount"]').val(order.supplementAmount);
		$('[name="supplementStatus"]').val(order.supplementStatus);

	};

	window.bindEvent = {
		toggle: function () {
			$('#toggle').find("i").toggleClass("down");
			$('#orderDetail').toggle();
		},
		useBalance: function () {
			var obj = $('#useBalance');

			if (obj.is('.checked')) {
				obj.removeClass('checked').addClass('unchecked');
			} else {
				obj.removeClass('unchecked').addClass('checked');
			}

			if ($('#useBalance').is('.checked')) {
				if (totalWeight >= productGoldWeight) {
					$('#purchase_weight_span').text('0g');
					$('#pay_money_1').text('0');
					$('#pay_money_2').text('.00');
				} else {
					$('#purchase_weight_span').text($.sumAmount(productGoldWeight, -totalWeight) + 'g');
					$('#pay_money_1').text(('' + order.supplementAmount).split('.')[0]);
					$('#pay_money_2').text('.' + (('' + order.supplementAmount).split('.')[1] || "00"));
				}
				$('[name="deductFlag"]').val("1");

			} else {
				$('#purchase_weight_span').text(productGoldWeight + 'g');
				$('[name="deductFlag"]').val("0");

				$('#pay_money_1').text(('' + orderAmount).split('.')[0]);
				$('#pay_money_2').text('.' + (('' + orderAmount).split('.')[1] || "00"));
			}
		},
		submit: function () {
			var data = mainForm.getFormJson();

			if (!$.valiBlank(data.realName, "请输入姓名")) {
				return;
			}
			if (!$.valiBlank(data.identityCardNo, "请输入身份证号")) {
				return;
			}
			if (!$.valiIdentityNo(data.identityCardNo)) {
				return;
			}

			$.request({
				url: "/member/modify",
				data: {
					realName: data.realName,
					identityCardNo: data.identityCardNo,
					form_token: $('[name="form_token"]').val()
				},
				successCallBack: function (response) {
					if (response.code == "200") {
						$.openNewWin('buy_gold_and_exchange_step2.htm?deductFlag=' + data.deductFlag + '&orderNo=' + order.orderNo, '扫码兑换');
					} else {
						alert(response.msg || '系统错误');
					}
				},
				onerror: function (response) {
					alert(response.msg || '系统错误');
				}
			});



		}
	};

	main();
});