mui.plusReady(function () {
	var mainForm, user, order, orderNo, purchasePrice, productGoldWeight, totalWeight, supplementAmount, supplementWeight, consumeGoldAmount;
	var main = function () {
		mainForm = $('#mainForm');
		$.getToken();

		// 获取订单数据
		orderNo = getParam('orderNo');
		initData();
	};

	var initData = function () {
		$.request({
			url: "/order/consume/query",
			data: {
				orderNo: orderNo
			},
			successCallBack: function (response) {
				order = response.data;
				setOrderDetail(response.data);
			}
		});
	};

	var setOrderDetail = function () {
		// 设置订单编号
		$('#orderNo').text(order.orderNo);

		// 设置订单详情信息
		var weightArr = order.productGoldWeightStr.split(',');
		var skuArr = order.productSku.split(',');
		for (var i = 0; i < skuArr.length; i++) {
			var temp = [];
			temp.push('<div class="item">');
			temp.push('<span class="s1">#' + (i + 1) + '</span>');
			temp.push('<span class="s2">' + skuArr[i] + '</span>');
			temp.push('<span class="s3">' + weightArr[i] + '克</span>');
			temp.push('</div>');
			$('#orderDetail').append(temp.join(''));
		}
		$.each(order.productGoldWeightStr.split(','), function () {});		

		// 设置黄金牌价
		purchasePrice = order['goldUnitPrice'];		
		$('#gold_price_span .s2').text(('' + purchasePrice).split('.')[0]);
		$('#gold_price_span .s3').text('.' + (('' + purchasePrice).split('.')[1] || "00"));
		

		// 设置应付金额
		supplementAmount = order['supplementAmount'];
		$('#pay_money_1').text(('' + supplementAmount).split('.')[0]);
		$('#pay_money_2').text('.' + (('' + supplementAmount).split('.')[1] || "00"));
		
		// 设置购入克重
		supplementWeight = $.mulAmount(supplementAmount, 1/purchasePrice);
		$('#purchase_weight_span').text(supplementWeight + 'g');

		// 设置总计订单黄金重量和订单金额		
		$('#total_weight .s2').text(('' + order['productGoldWeight']).split('.')[0]);
		$('#total_weight .s3').text('.' + (('' + order['productGoldWeight']).split('.')[1] || "00") + ' g');
	
		$.request({
			type: "GET",
			url: "/member/query",
			onsuccess: function (response) {
				user = response.data;
				totalWeight = user.totalWeight;
				$('#gold_weight_span').html(totalWeight);
				if (totalWeight > 0) {
					$('.js-useBalance').show();
				}
				
				$('#realName_p').text(user.realName);
				$('#identityCardNo_p').text(user.identityCardNo);
				if (user) {
					localStorage.setItem('user', JSON.stringify(response.data));
				}
			},
			onerror: function () {
				alert('查询客户信息失败');
			}
		});
	};

	window.bindEvent = {
		toggle: function () {
			$('#toggle').find("i").toggleClass("down");
			$('#orderDetail').toggle();
		},

		submit : function() {
			var data = mainForm.getFormJson();
			data.orderNo = orderNo;
			
			$.loading();
			$.request({
				url : "/order/consume/cancel",
				data : data,
				successCallBack : function(response) {
					if (response.code == '200') {
						$.openNewWin('operate_success_wrapper.html?action=cancel_buy_gold_and_exchange', '取消兑换成功', false);
					} else {
						mui.toast(response.msg || '操作失败');
					}
				},
				onerror:function(response){
					mui.toast(response.msg || '操作失败');
				}
			});
		}
	};
	main();
});