
mui.plusReady(function () {
	var mainForm, mobile, orderNo, deductFlag, order, intervalId, totalWeight;

	var main = function () {
		mainForm = $('#mainForm');
		$.getToken();
		mobile = JSON.parse(localStorage.getItem("user")).mobile;
		totalWeight = JSON.parse(localStorage.getItem("user")).totalWeight;
		orderNo = getParam('orderNo');
		deductFlag = getParam('deductFlag');
		initData();
	};

	var initData = function () {
		$.request({
			url: "/order/consume/query",
			data: {
				orderNo: orderNo
			},
			successCallBack: function (response) {
				order = response.data;
				setOrderDetail(response.data);
			}
		});
	};

	var setOrderDetail = function (data) {
		var content = $.render($('#exchangeDetailTpl').html(), data);
		$('[name="form_token"]').after(content);
	};

	var countSeconds = function () {
		var count = 60;
		$('#sendCode').text('重新发送(' + (count--) + ')');
		clearInterval(intervalId);
		intervalId = null;
		intervalId = setInterval(function () {
			if (count == 0) {
				clearInterval(intervalId);
				intervalId = null;
				$('#sendCode').text('重新发送');
				$('#sendCode').removeAttr('disabled');
			} else {
				$('#sendCode').text('重新发送(' + (count--) + ')');
			}
		}, 1000);
	};

	window.bindEvent = {
		sendCode: function (dom) {
			if ($('#sendCode').attr('disabled')) {
				return;
			}
			$(dom).attr('disabled', true);
			$.request({
				url: "/member/send_mobile_captcha",
				data: {
					mobile: mobile,
					form_token: $('[name="form_token"]').val()
				},
				successCallBack: function (response) {

					if (response.code == "200") {
						mui.alert('验证码已经发送到您的手机' + (mobile.slice(0, 3)) + '***' + (mobile.slice(7, 11)));
						countSeconds();
					} else {
						mui.alert(response.msg || '发送失败，请重新发送。');
						$('#sendCode').removeAttr('disabled');
					}
				},
				onerror: function (response) {
					mui.alert(response.msg || '发送失败，请重新发送。');
					$('#sendCode').removeAttr('disabled');
				}
			});
			$.getToken();
		},
		submit: function () {
			var data = mainForm.getFormJson();
			if (!$.valiBlank(data.mobileCaptcha, "请输入验证码")) {
				return;
			}
			document.activeElement.blur();
			$.loading();
			var data = mainForm.getFormJson();
			data.orderNo = orderNo;
			data.deductFlag = deductFlag;
			// 客户选择使用余额
			if (deductFlag == "1") {							
				$.request({
					url: "/order/consume/pay",
					data: data,
					autoCloseWaiting: false,
					successCallBack: function (response) {									
						var orderData = response.data;
						if (orderData.supplementStatus == "1") {
							// $.openNewWin('buy_gold_step2.htm?f=3&data=' + encodeURIComponent(JSON.stringify({
							// 	goldAmount: orderData.supplementAmount,
							// 	orderNo: orderData.orderNo,
							// 	deductFlag: deductFlag
							// })), '在线支付');
							var slidBackEnabled = true;
							$.request({
								url: "/pay/query_channel",
								data: {
									orderNo: orderData.orderNo, 
									deductFlag: deductFlag,
									paymentType: '5'
								},
								successCallBack: function (res) {
									if (res.code == '200') {
										// 大额--打开的支付页面没有右滑功能
										if(res.data == '1') {
											slidBackEnabled = false;
										}
									} else {
										mui.alert(res.msg || '操作失败');
									}
									$.newWin('在线支付', {
										url : 'buy_gold_step2.htm?f=3&data=' + encodeURIComponent(JSON.stringify({
											goldAmount: orderData.supplementAmount,
											orderNo: orderData.orderNo,
											deductFlag: deductFlag
										})), 
										name : 'buy_gold_step2',
										slidBackEnabled: slidBackEnabled,
									});
								}
							});
						} else {										
							$.openNewWin('operate_success_wrapper.html?action=buy_gold_and_exchange&orderNo='+orderNo, '扫码兑换成功', false);
						}

					},
					onerror: function (response) {
						alert(response.msg || '系统错误');
					}
				});
				// 客户选择不使用余额---测试OK
			} else {
				// $.openNewWin('buy_gold_step2.htm?f=3&data=' + encodeURIComponent(JSON.stringify({
				// 	goldAmount: order.orderAmount,
				// 	orderNo: order.orderNo,
				// 	deductFlag: deductFlag 
				// })), '在线支付');
				var slidBackEnabled = true;
				$.request({
					url: "/pay/query_channel",
					data: {
						orderNo: order.orderNo, 
						deductFlag: deductFlag,
						paymentType: '5'
					},
					successCallBack: function (res) {
						if (res.code == '200') {
							// 大额--打开的支付页面没有右滑功能
							if(res.data == '1') {
								slidBackEnabled = false;
							}
						} else {
							mui.alert(res.msg || '操作失败');
						}
						$.newWin('在线支付', {
							url : 'buy_gold_step2.htm?f=3&data=' + encodeURIComponent(JSON.stringify({
								goldAmount: order.orderAmount,
								orderNo: order.orderNo,
								deductFlag: deductFlag 
							})), 
							name : 'buy_gold_step2',
							slidBackEnabled: slidBackEnabled,
						});
					}
				});
			}
		}
	};
	$('[name="mobileCaptcha"]').on('keyup', function (e) {
		e.preventDefault();
		if ($('[name="mobileCaptcha"]').val()) {
			$('[role="submit"]').removeAttr('disabled');
		} else {
			$('[role="submit"]').attr('disabled', true);
		}
	});
	main();
});
