mui.plusReady(function() {
	var mainForm, purchasePrice, publicPrice;
	var main = function() {
		mainForm = $('#mainForm');
		$.getToken();
		initData();
		var user = localStorage.getItem('user');
		if (user) {
			user = JSON.parse(user);
			if(user.realName) {
				$('#realName').val(user.realName).attr('readonly', 'readonly').css('color', '#949494');
			}

			if(user.identityCardNo) {
				$('#identity').val(user.identityCardNo).attr('readonly', 'readonly').css('color', '#949494');
			}
			
		}
	};

	var initData = function() {
		$.request({
			type : "GET",
			url : "/index/gold_price",
			successCallBack : function(response) {
				if (response.code == "200") {
					purchasePrice = response.data.purchasePrice;
					publicPrice = response.data.publicPrice;
					$('#gold_price_span .s2').text(('' + publicPrice).split('.')[0]);
					$('#gold_price_span .s3').text('.' + (('' + publicPrice).split('.')[1] || "00"));

					// purchasePrice = response.data.purchasePrice;
					// $('#gold_price_span .s2').text(('' + purchasePrice).split('.')[0]);
					// $('#gold_price_span .s3').text('.' + (('' + purchasePrice).split('.')[1] || "00"));
				} else {
					mui.toast('获取金价失败')
				}
			}
		});
	};

	window.bindEvent = {
		agree : function(dom) {
			var obj = $(dom);
			if (obj.is('.checked')) {
				obj.removeClass('checked').addClass('unchecked');
				$('#submit').attr('disabled', true);
			} else {
				obj.removeClass('unchecked').addClass('checked');
				$('#submit').removeAttr('disabled');
			}
		},
		submit : function() {
			var data = mainForm.getFormJson();
			if (!$.valiBlank(data.purchaseGoldWeight, "请输入购买克数")) {
				return;
			}
			if (!$.valiWeight(data.purchaseGoldWeight, "购买克数应大于等于0.01g小于等于9999.99g")) {
				return;
			}
			if (data.purchaseGoldWeight > 9999.99) {
				
				return;
			}
			if (!$.valiBlank(data.realName, "请输入姓名")) {
				return;
			}
			if (!$.valiBlank(data.identityCardNo, "请输入身份证号")) {
				return;
			}
			if (!$.valiIdentityNo(data.identityCardNo)) {
				return;
			}
			$.loading();
			$.request({
				url : "/order/purchase",
				data : data,
				successCallBack : function(response) {

					if (response.code == '200') {
						var slidBackEnabled = true;
						$.request({
							url: "/pay/query_channel",
							data: {
							  orderNo: response.data.orderNo, 
							  deductFlag: response.data.deductFlag ? response.data.deductFlag : '0',
							  paymentType: '1'
							},
							successCallBack: function (res) {
							  if (res.code == '200') {
								// 大额--打开的支付页面没有右滑功能
								if(res.data == '1') {
									slidBackEnabled = false;
								}
							  } else {
								mui.alert(res.msg || '操作失败');
							  }
							  $.newWin('在线支付', {
								  url : 'buy_gold_step2.htm?data=' + encodeURIComponent(JSON.stringify(response.data)), 
								  name : 'buy_gold_step2',
								  slidBackEnabled: slidBackEnabled,
							  });
							}
						  });
					} else {
						mui.alert(response.msg || '操作失败');
					}
				}
			});
		}
	};
	
	//自动计算资金总额   先判断浏览器是不是万恶的IE，没办法，写的东西也有IE使用者  
    var bind_name = 'input';  
    if (navigator.userAgent.indexOf("MSIE") != -1){  
        bind_name = 'propertychange';  
    }  
    $('[name="purchaseGoldWeight"]').bind(bind_name, function(e){  
        var purchaseGoldWeight = $('[name="purchaseGoldWeight"]').val();
		if (isNaN(purchaseGoldWeight)) {
			$('#total_money').text('--');
			$('#discount_money').text('--');
			$('#real_money').text('--');
		} else {
			var orderAmount = $.toAmount($.mulAmount(publicPrice, purchaseGoldWeight));
			$('#total_money .s2').text(('' + orderAmount).split('.')[0]);
			$('#total_money .s3').text('.' + (('' + orderAmount).split('.')[1] || "00"));

			var discountAmount = $.toAmount($.mulAmount((publicPrice-purchasePrice), purchaseGoldWeight));
			$('#discount_money .s2').text(('' + discountAmount).split('.')[0]);
			$('#discount_money .s3').text('.' + (('' + discountAmount).split('.')[1] || "00"));

			var realAmount = $.toAmount($.mulAmount(purchasePrice, purchaseGoldWeight));
			$('#real_money .s2').text(('' + realAmount).split('.')[0]);
			$('#real_money .s3').text('.' + (('' + realAmount).split('.')[1] || "00"));

			// var orderAmount = $.toAmount($.mulAmount(purchasePrice, purchaseGoldWeight));
			// $('#total_money .s2').text(('' + orderAmount).split('.')[0]);
			// $('#total_money .s3').text('.' + (('' + orderAmount).split('.')[1] || "00"));
		} 
    })  

	
	// 自动计算资金总额
	$('[name="purchaseGoldWeight"]').on('keydown', function(e) {
		console.log('keydown ....');
		

	});

	main();
});
