(function() {

	mui.plusReady(function() {

		$api.fixStatusBar($api.dom('#head-content'));
		api.setStatusBarStyle({
			style : 'dark',
			color : '#f37202'
		});
		_.setDownRefresh(function() {
			pageNo = 1;
			initData(function() {
				_.endDownRefresh();
			});
		});
		var moreDropDown = $('.more-dropdown');
		var more = $('.more');
		$(document).on('touchstart', function(e) {
			var t = $(e.target);
			setTimeout(function() {
				if (moreDropDown.hasClass('open') && t.closest(more).length === 0) {
					moreDropDown.toggleClass('open');
				}
			});
		});
		api.addEventListener(
			{
				name: 'reviceUnreadMessageCount'
			},
			function(ret) {
				if (ret.value.count !== 0) {
					$('.point').css({display: 'inline-block'});
				}
			}
		)

		var pageSize, pageNo, isLoading, total, banners, swiper;
		var main = function() {
			pageNo = 1;
			pageSize = 10;
			total = 1;
			isLoading = false;
			initJiGuang();
			initData();
			showTips();
		};

		var initJiGuang = function() {
			var ajpush = api.require('ajpush');

			if (!ajpush) {
				return;
			}
			function clearPush() {
				ajpush.clearNotification({
					id: '-1'
				});
			}
			ajpush.init(function(ret) {
				if (ret && ret.status == '1'){
					ajpush.getRegistrationId(function(ret) {
						var cid = ret.id;
						localStorage.setItem('pushCid', cid);
					});
				}
			});
			// 应用启动清除通知
			clearPush();
			// 应用从后台进入前台清除通知
			api.addEventListener({
			    name:'resume'
			}, function(ret, err){
				clearPush();
			});
			window.reloadMessageCount = function () {
				$.request({
					type : "GET",
					url : "/member/query",
					onsuccess : function(response) {
						localStorage.setItem('is_logined', '1');
						var user = response.data;
						if (user.unreadMessageCount !== 0) {
							$('.point').css({display: 'inline-block'});
						} else {
							$('.point').css({display: 'none'});
						}
					},
				});
			};
			api.addEventListener(
				{
					name: 'reloadMessageCount',
				},
				function() {
					reloadMessageCount();
				}
			);
			// ios下，当应用在前台时，需要手动通知用户
			ajpush.setListener(function(ret) {
				window.reloadMessageCount();
				api.notification({
					notify: {
						title: ret.title,
						content: ret.content,
						extra: ret.extra
					}
				})
			});

			if(api.systemType.toLowerCase() == 'ios') {
				api.addEventListener({
					name: 'noticeclicked'
				}, function(ret, err) {
					if (ret && ret.value) {
						var ajpush = ret.value;
						var extra = ajpush.extra;
						openRedPackage(extra.invite_regist_gift_message);
					}
				})
			}else {
				api.addEventListener({
					name: 'appintent'
				}, function(ret, err) {
					if (ret && ret.appParam.ajpush) {
						var ajpush = ret.appParam.ajpush;
						var extra = ajpush.extra;
						openRedPackage(extra.invite_regist_gift_message);
					}
				})
			}

			function openRedPackage(gift) {
				if (gift === undefined) {
					return;
				}
	  		api.openWin({
	  			name : 'red_package',
	  			url : 'common.html',
	  			pageParam : {
	  				title : '领取红包',
	  				url : 'redPackage.html',
	  				name : 'redPackage',
	  				canBack : true,
	  				hasRightIcon : true,
	  				pageParam : {
	            gift: gift
	          }
	  			}
	  		});
	    };

		};

		var initGeTui = function() {
			var uzgetuisdk = api.require('pushGeTui');

			if (!uzgetuisdk) {
				return;
			}
			uzgetuisdk.initialize(function(ret) {
				localStorage.setItem('geTuiCid', '');
				if(ret.type == 'cid') {
					localStorage.setItem('geTuiCid', ret.cid);
				}
			});
			uzgetuisdk.payloadMessage(function(ret) {
			});
		};

		var initData = function(callback) {

			$.request({
				type : "GET",
				url : "/index/banners/list",
				onsuccess : function(response) {
					if(response.code == '200' && response.data.length>1 && (!swiper)) {
						var content = $.render($('#bannerTpl').html(), response.data);
						$('#divider').before(content);
						swiper = new Swiper('.swiper-container', {
							onTap: function(swiper){
								var item = $(swiper.clickedSlide);
								var bannerId = item.attr('bannerId');
								var bannerLinkUrl = item.data('url') || '';
								var url;

								if (bannerLinkUrl.indexOf('/') === 0) {
									url = config.host + bannerLinkUrl;
								} else if (bannerLinkUrl.indexOf('http') === 0) {
									url = bannerLinkUrl;
								} else {
									url = 'bannerContent.htm?bannerId=' + bannerId;
								}
								$.openNewWin(url, '详情');
							},
							onTouchStart: function (swiper) {
								api.setFrameAttr({
									name: api.frameName,
									bounces: false
								});
							},
							onTouchEnd: function (swiper) {
								api.setFrameAttr({
									name: api.frameName,
									bounces: true
								});
							},
							autoplay : 1500,
							centeredSlides: true,
							paginationClickable: true,
							spaceBetween: 20,
							slidesPerView: 'auto',
							autoplayDisableOnInteraction: false,
							loop: true,
						});
					}
				}
			});

			$.request({
				type : "GET",
				url : "/index/gold_price",
				onsuccess : function(response) {
					if (response.data.code === 800) {
						return;
					}
					localStorage.setItem('gold_price', JSON.stringify(response.data));
					$('#gold_price_span').text(response.data.purchasePrice);
					$('#save_money_span').text(Math.round($.toAmount(response.data.publicPrice)));
					$('#gold_redeem_price_span').text(parseFloat(response.data.redeemPrice).toFixed(2));
				}
			});

			queryRecords(callback);
		};

		var queryRecords = function(params, callback) {
			if ( typeof params == 'function') {
				callback = params;
				params = {};
			}

			$.request({
				url : "/index/product/list",
				data : $.extend({
					pageSize : pageSize,
					pageNo : pageNo
				}, params || {}),
				onerror : function() {
					callback && callback();

				},
				successCallBack : function(response) {
					callback && callback();
					isLoading = false;

					if (response.data.code === 800) {
						return;
					}
					if (response && response.data && response.data.data) {
						if (pageNo == "1") {
							//console.log(pageNo+'----》');
							// var html = $.render($('#recommendProductsTpl').html(), response.data.data);

							// $('#recommendProductsUl').html(html);
							var filterData = _.filter(response.data.data, function(obj) {
								return true;
							});

							$('#productsUl').html($.render($('#productsTpl').html(), _.slice(filterData, 0, 7)));
							$('#historyProductsUl').html($.render($('#historyProductsTpl').html(), _.slice(filterData, 7)));
						} else {
							$('#historyProductsUl').append($.render($('#historyProductsTpl').html(), response.data.data));
						}
						api.parseTapmode();

						total = response.data.total;
						pageNo++;
					} else {
						api.toast({
							msg : '查询产品信息失败！'
						});
					}
				}
			});
		};

		window.bindEvent = {
			toggleMore: function() {
				moreDropDown.toggleClass('open');
				$('#today-price-wrapper').removeClass('down');
			},
			openScan: function() {
				// 获取相机权限
				// var permission = api.hasPermission({
				//    list:['camera']
				// });
				// alert(permission.granted);
				// if(!permission.granted){}
				
				api.requestPermission({
				    list:['camera'],
				    code:1
				}, function(ret, err){
				    
				});
				
				var FNScanner = api.require('FNScanner');
				moreDropDown.toggleClass('open');
				FNScanner.openScanner({
				    autorotation: true
				}, function(ret, err) {
				    if (ret.eventType == 'success') {
				    	var orderNo = ret.content ? ret.content.split('=')[1] : "";
				    	if(orderNo) {
				    		$.request({
								url : "/order/temp_to_consume/create",
								data : {orderNo: orderNo},
								successCallBack : function(response) {
									if (response.code == '200') {
										$.openNewWin('buy_gold_and_exchange_step1.htm?data=' + encodeURIComponent(JSON.stringify(response.data)), '购金并兑换');
									} else {
										alert(response.msg || '操作失败');
									}
								}
							});
				    	}else {
				    		alert("二维码信息不正确");
				    	}
				    }
				});
			},
			showWin: function(e, name) {
				moreDropDown.toggleClass('open');
				showWin(e, name);
			},

			openBuyGoldWin : function() {
				var is_logined = localStorage.getItem('is_logined');
				if (is_logined == 1) {
					$.openNewWin('buy_gold_step1.htm', '购  入');
				} else {
					$.openNewWin('login.htm', '登录');
				}
			},
			openRedeemProductWin : function() {
				var is_logined = localStorage.getItem('is_logined');
				if (is_logined == 1) {
					$.openNewWin('redeem_product_step1.htm', '旧金回收预约登记');
				} else {
					$.openNewWin('login.htm', '登录');
				}
			},
			todayPrice : function() {
				$('#today-price-wrapper').removeClass('down');
				$('#arrow').removeClass('down');
			},
			priceArea : function() {
				$('#arrow').toggleClass('down');
				$('#today-price-wrapper').toggleClass('down');
			},
			productDetail : function(productId) {
				api.openWin({
					name : 'product_detail_wrapper',
					url : 'product_detail_wrapper.html',
					pageParam : {
						productId : productId
					}
				});
			},
			today : function() {
				$('#recommendProductsUl').show();
				$('#productsUl').hide();
				$('#history').removeClass('active');
				$('#today').addClass('active');
				$('#historyProductsUl').hide();
				$('#historyProductsUlTitle').hide();
			},
			history : function() {
				$('#recommendProductsUl').hide();
				$('#productsUl').show();
				$('#today').removeClass('active');
				$('#history').addClass('active');
				$('#historyProductsUl').show();
				$('#historyProductsUlTitle').show();
			},
			xianSthName : function() {
				api.openWin({
					name : 'online_exchange_products_wrapper',
					url : 'online_exchange_products_wrapper.htm'
				});
			}
		};
		main();

	});

})();
