
mui.plusReady(function() {
	var mainForm, mobile, orderNo, order, intervalId;

	var main = function() {
		mainForm = $('#mainForm');
		$.getToken();
		mobile = JSON.parse(localStorage.getItem("user")).mobile;
		orderNo = getParam('orderNo');		 
		initData();		
	};

	var initData = function() {		
		$.request({
			url : "/order/consume/query",
			data : {
				orderNo : orderNo
			},
			successCallBack : function(response) {
				order = response.data;

				setOrderDetail(response.data);
			}
		});
	};

	var setOrderDetail = function(data) {
		var content = $.render($('#exchangeDetailTpl').html(), data);
		$('[name="form_token"]').after(content);
	};

	var countSeconds = function() {
		var count = 60;
		$('#sendCode').text('重新发送(' + (count--) + ')');
		clearInterval(intervalId);
		intervalId = null;
		intervalId = setInterval(function() {
			if (count == 0) {
				clearInterval(intervalId);
				intervalId = null;
				$('#sendCode').text('重新发送');
				$('#sendCode').removeAttr('disabled');
			} else {
				$('#sendCode').text('重新发送(' + (count--) + ')');
			}
		}, 1000);
	};
	window.bindEvent = {
		sendCode:function(dom){
			if ($('#sendCode').attr('disabled')) {
				return;
			}
			$(dom).attr('disabled', true);
			$.request({
				url : "/security/send_mobile_captcha",
				data : {
					mobile : mobile,
					form_token:$('[name="form_token"]').val()
				},
				successCallBack : function(response) {

					if (response.code == "200") {
						mui.alert('验证码已经发送到您的手机' + (mobile.slice(0, 3)) + '***' + (mobile.slice(7, 11)));
						countSeconds();
					} else {
						mui.alert(response.msg || '发送失败，请重新发送。');
						$('#sendCode').removeAttr('disabled');
					}
				},
				onerror : function(response) {

					mui.alert(response.msg || '发送失败，请重新发送。');
//						$('#sendCode').attr('disabled', false);
					$('#sendCode').removeAttr('disabled');
				}
			});
			$.getToken();
		},
		submit:function(){
			var data = mainForm.getFormJson();
			if (!$.valiPayPwd(data.payPwd)) {
				return;
			}
			if (!$.valiBlank(data.mobileCaptcha, "请输入验证码")) {
				return;
			}
			document.activeElement.blur();
			$.loading();
			var data = mainForm.getFormJson();
			data.orderNo = orderNo;

			$.request({
				url : "/order/consume/pay",
				data : data,
				autoCloseWaiting : false,
				successCallBack : function(response) {
					if (getParam('supplementStatus') == 0) {//不需要补差价
						$.openNewWin('operate_success_wrapper.html?action=online_exchange&orderNo=' + orderNo, '提货成功', false);
					} else {
						// $.openNewWin('buy_gold_step2.htm?f=2&data=' + encodeURIComponent(JSON.stringify({
						// 	goldAmount : order.supplementAmount,
						// 	orderNo : orderNo
						// })), '在线支付');
						var slidBackEnabled = true;
						$.request({
							url: "/pay/query_channel",
							data: {
								orderNo: orderNo, 
								deductFlag: '0',
								paymentType: '2'
							},
							successCallBack: function (res) {
								if (res.code == '200') {
									// 大额--打开的支付页面没有右滑功能
									if(res.data == '1') {
										slidBackEnabled = false;
									}
								} else {
									mui.alert(res.msg || '操作失败');
								}
								$.newWin('在线支付', {
									url : 'buy_gold_step2.htm?f=2&data=' + encodeURIComponent(JSON.stringify({
										goldAmount : order.supplementAmount,
										orderNo : orderNo
									})), 
									name : 'buy_gold_step2',
									slidBackEnabled: slidBackEnabled,
								});
							}
						});
					}
				},
				onerror : function(response) {
					mui.alert(response.msg || '提交失败');
					$('#sendCode').removeAttr('disabled');
					$('#sendCode').text('重新发送');
					if (intervalId) {
						clearInterval(intervalId);
						intervalId = null;
					}
				}
			});

			function finishPay() {
				$.request({
					url : "/order/consume/pay",
					data : data,
					successCallBack : function(response) {
						$.openNewWin('operate_success_wrapper.html?action=online_exchange&orderNo=' + orderNo, '提货成功', false);
					},
					onerror : function(response) {
						mui.toast(response.msg || '提交失败');
						$('#sendCode').removeAttr('disabled');
						$('#sendCode').text('重新发送');
						if (intervalId) {
							clearInterval(intervalId);
							intervalId = null;
						}
					}
				});
			}
		}
	};
			 
	$.request({
		url : '/member/validate_pay_pwd',
		type : 'post',
		onsuccess : function(res) {
			if (res.data == 1) {
				//					$.openNewWin('set_pay_pwd.htm','设置支付密码');
			} else {
				var btnArray = ['不设置了', '好'];
				api.confirm({
					title : '提示',
					msg : '您没有设置支付密码，是否去设置支付密码？',
					buttons : btnArray
				}, function(ret, err) {
					if (ret.buttonIndex == 2) {
						$.openNewWin('set_pay_pwd.htm?f='+ api.winName, '设置支付密码');
					}
				});
			}
		},
		onerror : function(res) {
			console.log(JSON.stringify(res));
		}
	});
	$('[name="mobileCaptcha"]').on('keyup', function(e) {
		e.preventDefault();
		if ($('[name="mobileCaptcha"]').val()) {
			$('[role="submit"]').removeAttr('disabled');
		} else {
			$('[role="submit"]').attr('disabled', true);
		}
	});
	main();
});
