(function () {
	var review = {
		searchData: {
			pageSize: 10,
			pageNo: 1,
			productId: null
		},
		init() {
			this.load();
			this.count = 0;
			this.review = $('#review');
			this.moreReview = $('#moreReview');
			this.moreReview.click(function() {
				review.searchData.pageNo++;
				review.load();
			});
		},
		setProductId(productId) {
			this.searchData.productId = productId;
		},
		setUIScrollPicture(UIScrollPicture) {
			this.UIScrollPicture = UIScrollPicture;
		},
		getImgs(imgs) {
			var html = [];
			if (!imgs) {
				return '';
			}
			imgs = imgs.split(',');
			$.each(imgs, function(i, img) {
				html.push([
					'<a href="' + img + '">',
						'<img src="' + img + '" />',
					'</a>'
				].join(''));
			});
			return [
				'<div class="review-item-list" id="item_' + this.count + '">',
					html.join(''),
				'</div>'
			].join('');
		},
		addItem(data) {
			var html;
			var m = data.memberMobile.match(/([\d]{3})([\d]{4})([\d]{4})/);
			html = [
				'<div class="review-item">',
					'<div class="review-item-hd">',
						m
							? '<span class="review-item-title">' + m[1] + '****' + m[3] + '</span>'
							: '<span class="review-item-title"></span>'
						,
						'<span class="review-item-hd-ext">' + moment(data.reviewTime).format('YYYY-MM-DD HH:mm:ss') + '</span>',
					'</div>',
					'<div class="review-item-bd">',
						data.reviewContent,
						this.getImgs(data.reviewImgs),
					'</div>',
					!data.managerReplyContent ? '' : [
						'<div class="review-item-ft">',
							'<span>',
								'客服回复：',
							'</span>',
							data.managerReplyContent,
						'</div>'
					].join(''),
				'</div>'
			].join('');
			var item = $(html);
			this.review.append(item);
			if (data.reviewImgs) {
				var id = 'item_' + this.count;
				var detailPhoto = new SmartPhoto('#' + id + ' a');
				detailPhoto.on('open', function () {
					api.setFrameAttr({
						name: api.frameName,
						bounces: false
					});
					review.UIScrollPicture.hide();
				});
				detailPhoto.on('close', function () {
					api.setFrameAttr({
						name: api.frameName,
						bounces: true
					});
					review.UIScrollPicture.show();
				});
			}
			this.count++;
		},
		load() {
			$.loading();
			$.request({
				url: "/index/product/review/list",
				type: "GET",
				data: this.searchData,
				successCallBack: function (ret) {
					$.unloading();
					var list = ret.data;
					$.each(list, function(i, item) {
						review.addItem(item);
					});
					if (list.length < review.searchData.pageSize) {
						review.moreReview.css({ display: 'none' });
					}
				}
			});
		}
	};
	mui.plusReady(function () {
		var pageSize, pageNo, isLoading, productId, product;
		function getSearchData() {
		}
		var main = function () {
			pageNo = 1;
			pageSize = 10;
			total = 1;
			isLoading = false;
			productId = api.pageParam.productId;
			initData();
		};

		var initData = function () {
			$.loading();
			$.request({
				url: "/index/product/detail",
				type: "GET",
				data: {
					productId: productId
				},
				successCallBack: function (response) {
					$.unloading();
					if (response.data.code === 800) {
						return;
					}
					product = response.data;
					setProductDetail(response.data);

				}
			});
			queryRecords();
		};

		var setProductDetail = function (data) {
			var content = $.render($('#detailTpl').html(), data);
			$('#content').prepend(content);
			
			//,'+ (data.productAmount / JSON.parse(localStorage.getItem("gold_price"))["redeemPrice"]).toFixed(2) +'			
			api.execScript({
				frameName: 'product_buy',
				script: 'setGoldInfo(' + (data.productAmount / JSON.parse(localStorage.getItem("gold_price"))["purchasePrice"]).toFixed(2) + ');'
			});
			var UIScrollPicture = api.require('UIScrollPicture');
			var rem = $('html').css('font-size').replace('px', '');
			review.setProductId(productId);
			review.setUIScrollPicture(UIScrollPicture);
			review.init();

			var slider = $('#slider');
			var imgs = [data.mainImg].concat(JSON.parse(data.otherImg));
			if (imgs[1] === '') {
				imgs.pop();
			}
			var html = [];
			imgs.forEach(function (img) {
				html.push([
					'<a class="product_detail_img" href="' + img + '">',
						'<img src="' + img + '" style="visibility: hidden;" />',
						'<button class="weui-btn">查看大图</button>',
					'</a>'
				].join(''));
			});
			slider.html(html.join(''));
			var bannerPhoto = new SmartPhoto("#slider .product_detail_img");
			var bannerImgBoxes = slider.find('a').css({ display: 'none' });
			bannerImgBoxes[0].style.display = 'block';

			bannerPhoto.on('open', function () {
				api.setFrameAttr({
					name: api.frameName,
					bounces: false
				});
				UIScrollPicture.hide();
			});
			bannerPhoto.on('close', function () {
				api.setFrameAttr({
					name: api.frameName,
					bounces: true
				});
				UIScrollPicture.show();
			});


			UIScrollPicture.open({
				rect: {
					x: 0,
					y: 0,
					w: api.winWidth,
					h: 6.5 * rem
				},
				data: {
					paths: (JSON.parse(data.otherImg).length == "1" && JSON.parse(data.otherImg)[0] == "") ? [data.mainImg] : [data.mainImg].concat(JSON.parse(data.otherImg)),
				},
				styles: {
					indicator: {
						dot: {
							w: 8,
							h: 8,
							r: 4,
							margin: 8
						},
						align: 'center',
						color: '#ccc',
						activeColor: '#ff7701'
					}
				},
				placeholderImg: 'widget://res/slide1.jpg',
				contentMode: 'scaleToFill',
				interval: 3,
				fixedOn: api.frameName,
				loop: true,
				fixed: false
			});
			UIScrollPicture.addEventListener(
				{
					name: 'scroll',
				},
				function (ret, err) {
					bannerImgBoxes.css({ display: 'none' });
					bannerImgBoxes[ret.index].style.display = 'block';
				}
			);
			var detail = $('#product_detail');
			var imgs = detail.find('img');
			imgs.each(function (i, img) {
				img = $(img);
				var span = $('<a class="product_detail_img" href="' + img.attr('src') + '"></a>');
				img.before(span);
				span.append(img);
			});
			var detailPhoto = new SmartPhoto("#product_detail .product_detail_img");
			detailPhoto.on('open', function () {
				api.setFrameAttr({
					name: api.frameName,
					bounces: false
				});
				UIScrollPicture.hide();
			});
			detailPhoto.on('close', function () {
				api.setFrameAttr({
					name: api.frameName,
					bounces: true
				});
				UIScrollPicture.show();
			});
			api.parseTapmode();
		};

		var queryRecords = function () {
			if (pageNo > total) {
				mui.toast('没有更多了');
				return;
			}

			$.request({
				url: "/index/product/list",
				data: {
					pageSize: pageSize,
					pageNo: pageNo
				},
				successCallBack: function (response) {

					isLoading = false;
					if (response && response.data && response.data.data) {
						$('#detailProductsUl').append($.render($('#detailProductsTpl').html(), response.data.data));
						api.parseTapmode();
						total = response.data.total;
						pageNo++;
					} else {
						mui.alert('查询产品信息失败！');
					}
				}
			});
		};

		window.bindEvent = {
			productDetail: function (productId) {
				api.openWin({
					name: 'product_detail_wrapper' + productId,
					url: 'product_detail_wrapper.html',
					pageParam: {
						productId: productId
					}
				});
			},
			changeTabs: function(e, index) {
				var c = $(e);
				var id = '#item' + index + 'mobile';
				if (c.hasClass('mui-active')) {
					return;
				}
				c.addClass('mui-active').siblings().removeClass('mui-active');
				$(id).addClass('mui-active').siblings('.mui-slider-item').removeClass('mui-active');
			}
		};

		//		// 下拉查询产品
		//			$(document).off('scroll').on('scroll', function(e) {
		//				if (isLoading || $('#detailProductsUl').length == 0) {
		//					return;
		//				}
		//				docTop = $(this).scrollTop();
		//				windowHeight = $(window).height();
		//				docHeight = $(document).height();
		//				if (docTop + windowHeight + 100 - docHeight >= 0) {
		//					isLoading = true;
		//					queryRecords()
		//				}
		//			});

		window.tihuo = function (e) {
			var data = {
				productId: product.productId,
				sku: product.sku,
				productAmount: product.productAmount
			};

			$.loading();
			$.request({
				url: "/order/online_consume/pre_create",
				data: data,
				headers: { isAjax: true },
				successCallBack: function (response) {
					$.openNewWin('online_exchange_step1.htm?orderNo=' + response.data.orderNo, '线上提货');

				}
			});
		};

		main();
	});
})();
