(function () {
  mui.plusReady(function () {
    var mainForm, weightDesc, appointmentTime, storeId, timeData, stores = [];
    var TimeUIActionSelector = api.require('UIActionSelector');

    var main = function () {
      mainForm = $('#mainForm');
      $.getToken();
      initData();
    };

    var initData = function () {
      // timeData = window.bindEvent.getDateData();
      timeData = [
        {
          "name": "2019",
          "sub": [
            {
              "name": "03",
              "sub": [
                {
                  "name": "04"
                },
              ]
            },
          ]
        },
        {
          "name": "2020",
          "sub": [
            {
              "name": "03",
              "sub": [
                {
                  "name": "04"
                },
              ]
            },
          ]
        }
      ];
      $.request({
        type: "GET",
        url: "/index/list_store",
        data: {
          recoveryFlag: 1,
        },
        onsuccess: function (response) {
          if (response.data && response.data.length > 0) {
            // var stores = [];
            response.data.forEach(function (item) {
              stores.push({ name: item.storeName, id: item.id, address: item.storeAddress });
            });
            $('#storeIdBtn').click(function () {
              var UIActionSelector = api.require('UIActionSelector');
              UIActionSelector.open({
                datas: stores,
                layout: {
                  row: 5,
                  col: 1,
                  height: 30,
                  size: 12,
                  sizeActive: 14,
                  rowSpacing: 5,
                  colSpacing: 10,
                  maskBg: 'rgba(0,0,0,0.2)',
                  bg: '#fff',
                  color: '#888',
                  colorActive: '#ff8001',
                  colorSelected: '#ff8001'
                },
                animation: true,
                cancel: {
                  text: '取消',
                  size: 12,
                  w: 90,
                  h: 35,
                  bg: '#fff',
                  bgActive: '#ccc',
                  color: '#888',
                  colorActive: '#fff'
                },
                ok: {
                  text: '确定',
                  size: 12,
                  w: 90,
                  h: 35,
                  bg: '#fff',
                  bgActive: '#ccc',
                  color: '#888',
                  colorActive: '#fff'
                },
                title: {
                  text: '请选择',
                  size: 12,
                  h: 44,
                  bg: '#eee',
                  color: '#888'
                },
                fixedOn: api.frameName
              }, function (ret, err) {
                if (ret && ret.eventType === 'ok') {
                  console.log(JSON.stringify(ret));
                  storeId = ret.selectedInfo[0].id;

                  $("#storeIdBtn").html(ret.level1 || '请选择预约门店');
                  $("#address").val(ret.selectedInfo[0].address || '');
                }
              });
            });
          }
        }
      });
    };
    window.bindEvent = {
      agreeRedeemProduct: function (dom) {
        var obj = $(dom);
        if (obj.is('.checked')) {
          obj.removeClass('checked').addClass('unchecked');
          $('#submit').attr('disabled', true);
        } else {
          obj.removeClass('unchecked').addClass('checked');
          if ($("#agreeBurnCheck").is('.checked')) {
            $('#submit').removeAttr('disabled');
          }
        }
      },
      agreeBurnCheck: function (dom) {
        var obj = $(dom);
        if (obj.is('.checked')) {
          obj.removeClass('checked').addClass('unchecked');
          $('#submit').attr('disabled', true);
        } else {
          obj.removeClass('unchecked').addClass('checked');
          if ($("#agreeRedeemProduct").is('.checked')) {
            $('#submit').removeAttr('disabled');
          }
        }
      },

      // 判断是否是闰年
      isRunYear: function (year) {
        return (0 == year % 4 && (year % 100 != 0 || year % 400 == 0));
      },

      getDateData: function () {
        var year = new Date().getFullYear();
        var result = [
          {
            name: year,
          },
          {
            name: year + 1,
          }
        ];
        result.forEach((item, index) => {
          var month = 1;
          item.sub = [];
          if (index == 0) {
            month = new Date().getMonth() + 1;
          }
          for (var i = month; i <= 12; i++) {
            item.sub.push({
              name: i < 10 ? ('0' + i) : i
            });
          }
          item.sub.forEach((subItem, subIndex) => {
            var day = 1;
            var selectMonth = (+subItem.name) - 1;
            var monthEnd = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
            subItem.sub = [];
            if (index == 0 && subIndex == 0) {
              day = new Date().getDate();
            }

            // 闰年且2月，2月最多29天
            if (window.bindEvent.isRunYear(item.name)) {
              for (var i = day; i <= 29; i++) {
                subItem.sub.push({
                  name: i < 10 ? ('0' + i) : i
                });
              }

              // 非闰年
            } else {
              for (var i = day; i <= monthEnd[selectMonth]; i++) {
                subItem.sub.push({
                  name: i < 10 ? ('0' + i) : i
                });
              }

            }
          });
        });

        return result;
      },

      selectAppointmentTime: function () {
        var UIActionSelector = api.require('UIActionSelector');
        UIActionSelector.open({
          datas: window.bindEvent.getDateData(),
          layout: {
            row: 5,
            col: 3,
            height: 30,
            size: 12,
            sizeActive: 14,
            rowSpacing: 5,
            colSpacing: 10,
            maskBg: 'rgba(0,0,0,0.2)',
            bg: '#fff',
            color: '#888',
            colorActive: '#ff8001',
            colorSelected: '#ff8001'
          },
          animation: true,
          cancel: {
            text: '取消',
            size: 12,
            w: 90,
            h: 35,
            bg: '#fff',
            bgActive: '#ccc',
            color: '#888',
            colorActive: '#fff'
          },
          ok: {
            text: '确定',
            size: 12,
            w: 90,
            h: 35,
            bg: '#fff',
            bgActive: '#ccc',
            color: '#888',
            colorActive: '#fff'
          },
          title: {
            text: '请选择',
            size: 12,
            h: 44,
            bg: '#eee',
            color: '#888'
          },
          fixedOn: api.frameName
        }, function (ret, err) {
          if (ret && ret.eventType === 'ok') {
            var year = ret.level1;
            var month = ret.level2;
            var day = ret.level3;
            appointmentTime = year + '-' + month + '-' + day;
            $("#appointmentTimeBtn").html(appointmentTime || '请选择回收时间');
          }
        });
      },

      selectWeightDesc: function () {
        var UIActionSelector = api.require('UIActionSelector');
        UIActionSelector.open({
          datas: [{ name: '0-15克' }, { name: '15-30克' }, { name: '30克以上' }],
          layout: {
            row: 5,
            col: 1,
            height: 30,
            size: 12,
            sizeActive: 14,
            rowSpacing: 5,
            colSpacing: 10,
            maskBg: 'rgba(0,0,0,0.2)',
            bg: '#fff',
            color: '#888',
            colorActive: '#ff8001',
            colorSelected: '#ff8001'
          },
          animation: true,
          cancel: {
            text: '取消',
            size: 12,
            w: 90,
            h: 35,
            bg: '#fff',
            bgActive: '#ccc',
            color: '#888',
            colorActive: '#fff'
          },
          ok: {
            text: '确定',
            size: 12,
            w: 90,
            h: 35,
            bg: '#fff',
            bgActive: '#ccc',
            color: '#888',
            colorActive: '#fff'
          },
          title: {
            text: '请选择',
            size: 12,
            h: 44,
            bg: '#eee',
            color: '#888'
          },
          fixedOn: api.frameName
        }, function (ret, err) {
          if (ret && ret.eventType === 'ok') {
            weightDesc = ret.level1 || '';
            $("#weightDescBtn").html(ret.level1 || '请选择回收克重');
          }
        });
      },
      submit: function () {
        var data = mainForm.getFormJson();
        if (!$.valiBlank(data.userName, '请输入姓名')) {
          return;
        }
        if (!$.valiMobile(data.mobile)) {
          return;
        }
        data.weightDesc = weightDesc;
        data.appointmentTime = appointmentTime;
        data.storeId = storeId;
        if (!$.valiBlank(data.weightDesc, "请选择回收克重")) {
          return;
        }
        if (!$.valiBlank(data.appointmentTime, "请选择回收时间")) {
          return;
        }
        if (!$.valiBlank(data.storeId, "请选择回收地点")) {
          return;
        }
        $.openNewWin('redeem_product_step2.htm?data=' + encodeURIComponent(JSON.stringify(data)), '旧金回收预约登记');
      }
    };

    main();
  });
})();
