(function() {
	mui.plusReady(function() {
		var mainForm, user, gold_price;

		var main = function() {
			mainForm = $('#mainForm');
			$.getToken();
			initData();
		};

		var initData = function() {
			$.request({
				type : "GET",
				url : "/member/query",
				successCallBack : function(response) {
					if (response) {
						localStorage.setItem('user', JSON.stringify(response.data));
						user = JSON.parse(localStorage.getItem('user'));
						$('#accountNameDiv').text(user.realName || "");
						$('[name="accountName"]').val(user.realName || "");
						if(user.completeFlag == "0") {
							setTimeout(function() {
								// $.openNewWin('choose_third_login_action.htm?winName=p_redeem_step1', '成为金持会员');
								$.newWin('成为金持会员', {
									url : 'choose_third_login_action.htm?action=all', 
									name : 'choose_third_login_action',
									slidBackEnabled: false,
								});
							}, 500);
							return;
						}

						$.request({
							type : "GET",
							url : "/index/gold_price",
							successCallBack : function(response) {
								localStorage.setItem('gold_price', JSON.stringify(response.data));
								gold_price = response.data;
								if (!isNaN(user.totalWeight) && !isNaN(gold_price.redeemPrice)) {
									var msg = user.totalWeight + ' 克 x ' + gold_price.redeemPrice + ' 元/克 = ' + $.toAmount($.mulAmount(user.totalWeight, gold_price.redeemPrice)) + '元';
									$('[name="orderAmount"]').val($.toAmount($.mulAmount(user.totalWeight, gold_price.redeemPrice)));
									$('[name="goldUnitPrice"]').val(gold_price.redeemPrice);
									$('[name="goldWeight"]').val(user.totalWeight);
									$('#redeem-info').text(msg);
								}
							}
						});
					}
				}
			});
		};
		window.bindEvent = {
			agree : function(dom) {
				var obj = $(dom);
				if (obj.is('.checked')) {
					obj.removeClass('checked').addClass('unchecked');
					$('#submit').attr('disabled', true);
				} else {
					obj.removeClass('unchecked').addClass('checked');
					$('#submit').removeAttr('disabled');
				}
			},
			submit : function() {
				var btnArray = ['否', '是'];
				var data = mainForm.getFormJson();
				if (!$.valiBlank(data.bankName, "请输入银行名称")) {
					return;
				}
				if (data.goldWeight < 5) {
					alert('回收克数应大于等于5g');
					return;
				}
				$('[name="goldWeight"]').val(user.totalWeight);

				api.confirm({
					title : '确定',
					msg : '您可回收的重量为 ' + data.goldWeight + ' 克，总价为当前金价 ' + data.goldUnitPrice + ' 元/克 x ' + data.goldWeight + ' 克 = ' + data.orderAmount + ' 元，现在回收到账时间需要等待1-3个工作日，确认赎回吗？',
					buttons : btnArray
				}, function(ret, err) {
					var index = ret.buttonIndex;
					if (index == 2) {
						delete data.goldWeight;
						delete data.goldUnitPrice;
						delete data.orderAmount;
						$.loading();
						$.request({
							url : "/order/redeem",
							data : data,
							successCallBack : function(response) {
								$.openNewWin('redeem_step2.htm?orderNo=' + response.data.orderNo, '确认回收');
							},
							onerror:function(ret){
								alert(ret.msg||'');
							}
						});
					}
				});
			}
		};

		main();
	});
})();
