(function() {
	mui.plusReady(function() {
		var mainForm, mobile, orderNo, order, intervalId;

		var main = function() {
			mainForm = $('#mainForm');
			$.getToken();
			orderNo = getParam('orderNo');
			
			mobile = JSON.parse(localStorage.getItem('user')).mobile;
			initData();
		 
		};

		var initData = function() {
			$.loadPage("shop_exchange_step2_tpl.htm",
				function(response) {
					if(response) {
						$("#mainForm").after(response);
						$.loading();
						$.request({
							url: "/order/consume/query",
							data: {
								orderNo: orderNo
							},
							successCallBack: function(response) {
								order = response.data;
								setOrderDetail(response.data);
							}
						});
					}

				});
		};

		var setOrderDetail = function(data) {
			var content = $.render($('#exchangeDetailTpl').html(), data);
			$('[name="form_token"]').after(content);
		};

		var countSeconds = function() {
			var count = 60;
			$('#sendCode').text('重新发送(' + (count--) + ')');
			clearInterval(intervalId);
			intervalId = null;
//			$('#sendCode').attr('disabled', true);

			intervalId = setInterval(function() {
				if(count == 0) {
					clearInterval(intervalId);
					intervalId = null;
					$('#sendCode').text('重新发送');
					$('#sendCode').removeAttr('disabled');
				} else {
					$('#sendCode').text('重新发送(' + (count--) + ')');
				}
			}, 1000);
		};
		window.bindEvent = {
			sendCode:function(){
				if ($('#sendCode').attr('disabled')) {
					return;
				}
				$('#sendCode').attr('disabled', true);
				$.request({
					url: "/security/send_mobile_captcha",
					data: {
						mobile: mobile,
						form_token:$('[name="form_token"]').val()
					},
					successCallBack: function(response) {
						if(response.code == "200") {
							mui.alert('验证码已经发送到您的手机' + (mobile.slice(0, 3)) + '***' + (mobile.slice(7, 11)));
							countSeconds();
						} else {
							mui.alert(response.msg || '发送失败，请重新发送。');
							$('#sendCode').removeAttr('disabled');
						}
					},
					onerror: function(response) {
						mui.alert(response.msg || '发送失败，请重新发送。');
						$('#sendCode').removeAttr('disabled');
					}
				});
				$.getToken();
			},
			submit:function(){
				var data = mainForm.getFormJson();
				data.orderNo = orderNo;
				if(!$.valiPayPwd(data.payPwd)) {
					return;
				}
				if(!$.valiBlank(data.mobileCaptcha, "请输入验证码")) {
					return;
				}
				document.activeElement.blur();
				$.loading();
				$.request({
					url: "/order/consume/pay",
					data: data,
					successCallBack: function(response) {
						$.openNewWin('operate_loading.htm', '支付结果', false);
					}
				});
			}
		};
		$.request({
			url : '/member/validate_pay_pwd',
			type : 'post',
			onsuccess : function(res) {
				if (res.data == 1) {
					//					$.openNewWin('set_pay_pwd.htm','设置支付密码');
				} else {
					var btnArray = ['不设置了', '好'];
					api.confirm({
						title : '提示',
						msg : '您没有设置支付密码，是否去设置支付密码？',
						buttons : btnArray
					}, function(ret, err) {
						if (ret.buttonIndex == 2) {
							$.openNewWin('set_pay_pwd.htm?f='+ api.winName, '设置支付密码');
						}
					});
				}
			},
			onerror : function(res) {
				console.log(JSON.stringify(res));
			}
		}); 
		$('[name="mobileCaptcha"]').on('keyup', function(e) {
			e.preventDefault();
			if ($('[name="mobileCaptcha"]').val()) {
				$('[role="submit"]').removeAttr('disabled');
			} else {
				$('[role="submit"]').attr('disabled', true);
			}
		});
		main();
	});
})();